/*
 * Copyright 2011, 2012 Eric Chastain. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of
      conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright notice, this list
      of conditions and the following disclaimer in the documentation and/or other materials
      provided with the distribution.

THIS SOFTWARE IS PROVIDED BY ERIC CHASTAIN ''AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ERIC CHASTAIN OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those of the
authors and should not be interpreted as representing official policies, either expressed
or implied, of Eric Chastain.
*/

package me.chastain.chalkup;

import me.chastain.chalkup.R;

import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;
import android.widget.TextView;
import android.widget.AdapterView.OnItemClickListener;

public class Game extends ListActivity {
	
	String game_name = "";
	long game_id = 0;
	Cursor c;

	// We have to override onResume to refresh the ListView contents by re-querying the cursor its bound to.
	@Override
	public void onResume() {
		super.onResume();
		c.requery();
	}

    @Override
    public void onCreate(Bundle savedInstanceState) {
    	
        super.onCreate(savedInstanceState);
        this.setTitle("Game.java");
        if ( Global.showTitles == false ) { requestWindowFeature(Window.FEATURE_NO_TITLE); }
        
        fillData();

        setContentView(R.layout.game);

    	Bundle extras = getIntent().getExtras(); 
        if(extras != null) {
        	game_name = extras.getString("game_name");
        	// set title
        	//android_game_game_title
        	// Description
        	TextView d = (TextView)findViewById(R.id.android_game_game_title);
        	d.setText(game_name);
        	
        }

    	// Clicking an item in the list should open the turn screen as a dialog.
    	ListView lv = this.getListView();
    	
    	lv.setOnItemClickListener(new OnItemClickListener() {
    	    public void onItemClick(AdapterView<?> parent, View view, int position, long id) {

    	    	// Now launch the "turn" activity, which we've themed as a dialog in AndroidManifest.xml
        		Intent turn = new Intent(view.getContext(), Turn.class);
        		turn.putExtra("game_players_id", id);

        		//Toast.makeText(getApplicationContext(), "OH SHIT BOIIII!!! " + String.valueOf(id), Toast.LENGTH_LONG).show();
        		
        		// I have to figure out how to pull the TextView value of game_row_xml_score for the given row
        		//TextView c = (TextView) view.findViewById(R.id.game_row_xml_score);

        		//Toast.makeText(getApplicationContext(), c.getText(), Toast.LENGTH_SHORT).show();
        		//turn.putExtra("this_players_current_score", c.getText());
        		startActivity(turn);

    	    }
    	    
    	  });
    }

    public void fillData() {
        //http://thinkandroid.wordpress.com/2010/01/09/simplecursoradapters-and-listviews/
//*
    	Bundle extras = getIntent().getExtras(); 
        if(extras != null)
        {

        	game_id = extras.getLong("_id");

        	DB db = new DB(getApplicationContext());
        	db.open();

        	c = db.getAllGamePlayers(game_id);
        	startManagingCursor(c);

        	// the desired columns to be bound
        	String[] columns = new String[] { "name", "score" };

        	// the XML defined views which the data will be bound to
        	int[] to = new int[] { R.id.name, R.id.game_row_xml_score };

        	// create the adapter using the cursor pointing to the desired data as well as the layout information
        	
        	SimpleCursorAdapter mAdapter = new SimpleCursorAdapter(this, R.layout.game_row, c, columns, to);

        	// set this adapter as your ListActivity's adapter
        	this.setListAdapter(mAdapter);

        	// This is a bug, i get an error in logcat when trying to close this but the results are actually wrong when i dont. 
        	//db.close();
//*/
        	c.requery();
        }
    }
    
}
