/*
 * Copyright 2011, 2012 Eric Chastain. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of
      conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright notice, this list
      of conditions and the following disclaimer in the documentation and/or other materials
      provided with the distribution.

THIS SOFTWARE IS PROVIDED BY ERIC CHASTAIN ''AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ERIC CHASTAIN OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those of the
authors and should not be interpreted as representing official policies, either expressed
or implied, of Eric Chastain.
*/

package me.chastain.chalkup;

import java.util.ArrayList;

import me.chastain.chalkup.R;

import android.app.ListActivity;
import android.content.Intent;
import android.database.Cursor;
import android.os.Bundle;
import android.util.Log;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.ListView;
import android.widget.SimpleCursorAdapter;

public class GameAddParticipants extends ListActivity {

	long selectedParticipantId = 0;
	String listType = "teams";
	protected CheckBox checkBox;


    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);

        this.setTitle("GameAddParticipants.java");
        if ( Global.showTitles == false ) { requestWindowFeature(Window.FEATURE_NO_TITLE); }

        setContentView(R.layout.game_add_participants);

        fillData();

        Button letsGoButton = (Button) findViewById(R.id.game_add_participants_start_game); 

        letsGoButton.setOnClickListener(new View.OnClickListener() { 
    		public void onClick(View v) {

    			Bundle extras = getIntent().getExtras();
    			ListView lv = getListView();
    			
    			//listType = extras.getString("listType");

				// Open DB Connection
    	        DB db = new DB(getApplicationContext());
    	        db.open();

    	        // Create an array to store player_ids into
				ArrayList<Long> array_of_selected_ids = new ArrayList<Long>();

    			int listItemCount = lv.getChildCount();

    			for ( int i = 0 ; i < listItemCount ; i++ ) {
    			    CheckBox cbox = (CheckBox) ((View)lv.getChildAt(i)).findViewById(R.id.game_add_participants_list_checkbox);

    			    if( cbox.isChecked() ) {
    			    	array_of_selected_ids.add(new Long(lv.getItemIdAtPosition(i)));
    			    }
    			}

    			long new_game_id = 0;

    			new_game_id = db.insertGame(extras.getString("listType"), extras.getString("game_name"), "", array_of_selected_ids);

			    db.close();

    	    	Intent game = new Intent(getBaseContext(), Game.class);
    	    	game.putExtra("_id", new_game_id);
    	    	game.putExtra("game_name", extras.getString("game_name"));
    	    	startActivity(game);

    		}
    	});

    }

    private void fillData(){

        Bundle extras = getIntent().getExtras(); 

        if(extras == null){
            Log.d("GameAddParticipants", "NO EXTRAS FOUND!!!");
        }
        else
        {
        	listType = extras.getString("listType");
        	Log.d("GameAddParticipants", "listType = " + listType);

        	// Load the data necessary to populate the form from the teams table.
            DB db = new DB(getApplicationContext());
            db.open();

            Cursor c = db.getAllPlayers();

        	if ( listType.equals("players") ) { c = db.getAllPlayers(); }

        	startManagingCursor(c);

            // Columns to be bound
            String[] columns = new String[] { "name" };

            // The XML defined views which the data will be bound to
            int[] to = new int[] {  R.id.game_add_participant_list_name };

            // create the adapter using the cursor pointing to the desired data as well as the layout information
            SimpleCursorAdapter mAdapter = new SimpleCursorAdapter(this, R.layout.game_add_participants_row, c, columns, to);

            // set this adapter as your ListActivity's adapter
            this.setListAdapter(mAdapter);

            db.close();
        }
         
    }

}
