/*
 * Copyright 2011, 2012 Eric Chastain. All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are
permitted provided that the following conditions are met:

   1. Redistributions of source code must retain the above copyright notice, this list of
      conditions and the following disclaimer.

   2. Redistributions in binary form must reproduce the above copyright notice, this list
      of conditions and the following disclaimer in the documentation and/or other materials
      provided with the distribution.

THIS SOFTWARE IS PROVIDED BY ERIC CHASTAIN ''AS IS'' AND ANY EXPRESS OR IMPLIED
WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL ERIC CHASTAIN OR
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

The views and conclusions contained in the software and documentation are those of the
authors and should not be interpreted as representing official policies, either expressed
or implied, of Eric Chastain.
*/

package me.chastain.chalkup;

import me.chastain.chalkup.R;

import android.app.Activity;
import android.os.Bundle;
import android.view.View;
import android.view.Window;
import android.widget.Button;
import android.widget.TextView;

public class Turn extends Activity {

    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState) {

        super.onCreate(savedInstanceState);
        this.setTitle("Turn.java");
        if ( Global.showTitles == false ) { requestWindowFeature(Window.FEATURE_NO_TITLE); }

        setContentView(R.layout.turn);

        // + Button
    	Button PlusButton = (Button) findViewById(R.id.turn_plus_button); 
    	PlusButton.setOnClickListener(new View.OnClickListener() { 
    		public void onClick(View v) { 
    			long nscore = 0;
    			TextView score = (TextView)findViewById(R.id.turn_score);
    			String current_score = score.getText().toString();
    			nscore = Long.parseLong(current_score) + 1;
    			score.setText(String.valueOf(nscore));
    		}
    	});        
        
        // - Button
    	Button MinusButton = (Button) findViewById(R.id.turn_minus_button); 
    	MinusButton.setOnClickListener(new View.OnClickListener() { 
    		public void onClick(View v) { 
    			long nscore = 0;
    			TextView score = (TextView)findViewById(R.id.turn_score);
    			String current_score = score.getText().toString();
    			nscore = Long.parseLong(current_score) - 1;
    			score.setText(String.valueOf(nscore));
    		}
    	});

    	// OK Button
    	Button OKButton = (Button) findViewById(R.id.turn_ok_id); 
    	OKButton.setOnClickListener(new View.OnClickListener() { 
    		public void onClick(View v) { 
    			// Get game players id from extras
    			Bundle extras = getIntent().getExtras();
    			long game_players_id = extras.getLong("game_players_id");

    			// Get the current turn value to log from the textbox.
    			TextView score = (TextView)findViewById(R.id.turn_score);
    			String change = score.getText().toString();

    			DB db = new DB(getApplicationContext()); 
    			db.open(); 
    			db.turn(game_players_id, Long.valueOf(change));

    			Turn.this.finish();
    		}
    	});

    	// Cancel Button
    	Button CancelButton = (Button) findViewById(R.id.turn_cancel_id); 
    	CancelButton.setOnClickListener(new View.OnClickListener() { 
    		public void onClick(View v) { 
    			Turn.this.finish();
    		}
    	});
    	
    }
}
